
// define distinct values, counting from 1:
#define WILDMUTT_CHANNEL 1
#define TRANSFORM_CHANNEL 2
#define DETRANSFORM_CHANNEL 3
#define PULSE_CHANNEL 4

/*
signature:
 ADD_MARKER(channel, green, alpha, op, rate)
*/
// append different marker definitions
#define LIST_MARKERS \
ADD_MARKER(WILDMUTT_CHANNEL, 253, 251, 0, 0.0) \
ADD_MARKER(TRANSFORM_CHANNEL, 252, 251, 1, 3.0) \
ADD_MARKER(TRANSFORM_CHANNEL, 251, 251, 0, 0.0) \
ADD_MARKER(DETRANSFORM_CHANNEL, 250, 251, 1, 3.0) \
ADD_MARKER(DETRANSFORM_CHANNEL, 249, 251, 0, 0.0) \
ADD_MARKER(PULSE_CHANNEL, 248, 251, 1, 0.4) \
ADD_MARKER(PULSE_CHANNEL, 247, 251, 0, 0.0)

#define MARKER_RED 254

// Screen pixel that the marker ends up on if it uses channel k:
// Mapping follows structure that is like an inverted cantor pairing (but only producing coordinates with an even sum)
#define MARKER_POS(k) (ivec2(2*int(ceil(sqrt(k)) - 1.0),0) + (k - int((ceil(sqrt(k)) - 1.0)*(ceil(sqrt(k)) - 1.0)) - 1)*ivec2(-1, 1))
